//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <math.h>

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
unsigned int i,j;

PrerusUceni();
srand((unsigned) time(NULL));

for (i = 0; i < I; i++) {
        vstupy[i] = 0;
        perceptronyI[i] = vstupy[i];
        }

for (i = 0; i < I; i++)
  for (j = 0; j < H; j++) {
        wIH[i][j] = (double) rand()/RAND_MAX/3.3; //nahod. cislo -0.3;0.3
        deltawIH[i][j] = 0.0;
        if ((float)rand()/RAND_MAX >= 0.5)
                wIH[i][j] *= -1;
}


for(i =0; i < H; i++) {
        perceptronyH[i] = 0.0;
        prahyH[i] = 0.0;
        deltaprahyH[i] = 0.0;
       }

for (i = 0; i < H; i++)
  for (j = 0; j < O; j++) {
        wHO[i][j] = (double) rand()/RAND_MAX/3.3;
        deltawHO[i][j] = 0.0;
        if ((float)rand()/RAND_MAX >= 0.5)
                wHO[i][j] *= -1;
        }

for (i = 0; i < O; i++) {
        pozadovane_vystupy[i] = 0.0;
        perceptronyO[i] = 0.0;
        prahyO[i] = 0.0;
        deltaprahyO[i] = 0.0;
        vystupy[i] = 0.0;
        chyby_vystupu[i] = 0.0;
        }

E = Eo = 0.0; //celkova energie; energie
KRITERIUM = (double)ScrollBar2->Position/10.0;
pocet_cyklu = 0;

vzor = -1;
for (int i = 0; i <='z'-'a'; i++)
    polevzoru[i] = 'a'+i;
for (int i = 0; i <='Z'-'A'; i++)
    polevzoru[i+'z'-'a'+1] = 'A'+i;

VykresliPerceptrony();
Label10->Caption = AnsiString(polevzoru[vzor+1]); // musi byt pozdeji nez VykresliP.
Label11->Caption = E;
}
//---------------------------------------------------------------------------
void TForm1::VykresliPerceptrony() {


if (!CheckBox2->Checked) return;
//Label5->Caption = pocet_cyklu;
Label7->Caption = E;
Label10->Caption = AnsiString(polevzoru[vzor]);

MaskEdit1->Text = perceptronyI[0];
MaskEdit2->Text = perceptronyI[1];
MaskEdit3->Text = perceptronyI[2];
MaskEdit4->Text = perceptronyI[3];
MaskEdit5->Text = perceptronyI[4];
MaskEdit6->Text = perceptronyI[5];
MaskEdit7->Text = perceptronyI[6];
MaskEdit8->Text = perceptronyI[7];

Edit1->Text = AnsiString(perceptronyH[0]);
Edit2->Text = AnsiString(perceptronyH[1]);
Edit3->Text = AnsiString(perceptronyH[2]);
Edit4->Text = AnsiString(perceptronyH[3]);
Edit5->Text = AnsiString(perceptronyH[4]);

Edit6->Text = AnsiString(perceptronyO[0]);
Edit7->Text = AnsiString(perceptronyO[1]);
Edit8->Text = AnsiString(perceptronyO[2]);
Edit9->Text = AnsiString(perceptronyO[3]);
Edit10->Text = AnsiString(perceptronyO[4]);
Edit11->Text = AnsiString(perceptronyO[5]);
Edit12->Text = AnsiString(perceptronyO[6]);
Edit13->Text = AnsiString(perceptronyO[7]);

if (vystupy[0] != vstupy[0]) Label12->Font->Color=clRed;
else  Label12->Font->Color=clWindowText;
Label12->Caption = vystupy[0];

if (vystupy[1] != vstupy[1]) Label13->Font->Color=clRed;
else Label13->Font->Color=clWindowText;
Label13->Caption = vystupy[1];

if (vystupy[2] != vstupy[2]) Label14->Font->Color=clRed;
else Label14->Font->Color=clWindowText;
Label14->Caption = vystupy[2];

if (vystupy[3] != vstupy[3]) Label15->Font->Color=clRed;
else Label15->Font->Color=clWindowText;
Label15->Caption = vystupy[3];

if (vystupy[4] != vstupy[4]) Label16->Font->Color=clRed;
else Label16->Font->Color=clWindowText;
Label16->Caption = vystupy[4];

if (vystupy[5] != vstupy[5]) Label17->Font->Color=clRed;
else Label17->Font->Color=clWindowText;
Label17->Caption = vystupy[5];

if (vystupy[6] != vstupy[6]) Label18->Font->Color=clRed;
else Label18->Font->Color=clWindowText;
Label18->Caption = vystupy[6];

if (vystupy[7] != vstupy[7]) Label19->Font->Color=clRed;
else Label19->Font->Color=clWindowText;
Label19->Caption = vystupy[7];
}
//---------------------------------------------------------------------------


void TForm1::priloz_vybrany_vzor_na_vstupy_site(unsigned char krok)
{
//krok 1
char pom = 1;
for (int i = 0; i < I; i++) {
vstupy[i] = (krok & pom ? 1 : 0);
perceptronyI[i] = vstupy[i];
pom *=2;
}
for (int o = 0; o <  O; o++)
        pozadovane_vystupy[o] = vstupy[o];

}
//---------------------------------------------------------------------------
void TForm1::vypocti_vystupy_site() {
//krok 2
double fi;

for (int h = 0; h < H; h++)
 {
   fi = 0.0;
   for (int i = 0; i < I; i++)
         fi += (double)perceptronyI[i]*wIH[i][h];
   fi += prahyH[h];

   if (fi > 5000.0)    // jinak to pretece
           perceptronyH[h] = 1;
   else if (fi < -5000.0)
           perceptronyH[h] = 0;
   else
           perceptronyH[h] = 1/(1+exp(-gama*fi)); //=(0,1) --sigmoida
  }

 for (int o = 0; o < O; o++)
 {
   fi = 0;
   for (int h = 0; h < H; h++)
         fi += (double) perceptronyH[h]*wHO[h][o];
   fi += prahyO[o];

   if (fi > 5000.0)    // jinak to pretece
           perceptronyO[o] = 1;
   else if (fi < -5000.0)
           perceptronyO[o] = 0;
   else
           perceptronyO[o] = 1/(1+exp(-gama*fi)); //=(0,1) --sigmoida

 if (perceptronyO[o] >= 0.5)
          vystupy[o] = 1;
 else
          vystupy[o] = 0;
 }

}
//---------------------------------------------------------------------------
void TForm1::porovnej_vystupy_s_pozadovanymi_hodnotami() {
//krok 3
double pom;
Eo = 0.0;
for (int o = 0; o < O; o++)
       Eo += (perceptronyO[o] - pozadovane_vystupy[o])*
           (perceptronyO[o] - pozadovane_vystupy[o]);
Eo /=2;

E += Eo;

for (int o = 0; o < O; o++) {
        chyby_vystupu[o] = (pozadovane_vystupy[o] - perceptronyO[o])*gama*
                            perceptronyO[o]*(1.0-perceptronyO[o]);
        }


}
//---------------------------------------------------------------------------
void TForm1::modifikuj_vahy() {
//krok 4
double chyby_vrstvyH[H],suma;
//---------------- vystupni vrstva ---------------
for (int h = 0; h < H; h++)
  for (int o = 0; o < O; o++)
    {
        deltawHO[h][o] = ny*chyby_vystupu[o]*perceptronyH[h]+
                        alfa*deltawHO[h][o];
        wHO[h][o] += deltawHO[h][o];
    }

for (int o = 0; o < O; o++) {
        deltaprahyO[o] = ny*chyby_vystupu[o]+alfa*deltaprahyO[o];
        prahyO[o] +=deltaprahyO[o];
     }

//---------------- vrstva H ----------------------
for (int h = 0; h < H; h++)
   {
     suma = 0.0;
     for (int o = 0; o < O; o++)
        suma +=wHO[h][o]*chyby_vystupu[o];

     chyby_vrstvyH[h] = perceptronyH[h]*(1.0-perceptronyH[h])*suma;
   }

for (int i = 0; i < I; i++)
  for (int h = 0; h < H; h++)
   {
      deltawIH[i][h] = ny*chyby_vrstvyH[h]*perceptronyI[i]+
                      alfa*deltawIH[i][h];
      wIH[i][h] += deltawIH[i][h];
   }

for (int h = 0; h < H; h++)
    {
     deltaprahyH[h] = ny*chyby_vrstvyH[h]+alfa*deltaprahyH[h];
     prahyH[h] += deltaprahyH[h];
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn4Click(TObject *Sender)
{
//pocet_cyklu = 0;
//vzor = 'a' -1;
BitBtn4->Visible=false;
BitBtn2->Visible=false;
Timer1->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
++vzor;

if (vzor >= POCET_VZORU) {
//  if (CheckBox2->Checked)
        if (E <= KRITERIUM) {
                PrerusUceni();
                ShowMessage("Kriterium splnno!");
          }
        pocet_cyklu++;
        Label11->Caption = AnsiString(E);
        Label5->Caption = pocet_cyklu;
        E = 0.0;
        vzor = -1;
        return;
        }
//if (CheckBox2->Checked)
//        Label10->Caption = AnsiString(polevzoru[vzor]);
   priloz_vybrany_vzor_na_vstupy_site(polevzoru[vzor]);
   vypocti_vystupy_site();
   porovnej_vystupy_s_pozadovanymi_hodnotami();
   modifikuj_vahy();
VykresliPerceptrony();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{
Timer1->Interval=ScrollBar1->Max - ScrollBar1->Position+1;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::BitBtn2Click(TObject *Sender)
{
   priloz_vybrany_vzor_na_vstupy_site(MaskEdit9->Text.c_str()[0]);
   vypocti_vystupy_site();
   VykresliPerceptrony();
   if (CheckBox2->Checked)
         Label10->Caption = MaskEdit9->Text;
}
//---------------------------------------------------------------------------
void TForm1::PrerusUceni() {
                Timer1->Enabled =false;
                BitBtn4->Visible=true;
                BitBtn2->Visible=true;
}

void __fastcall TForm1::BitBtn5Click(TObject *Sender)
{
PrerusUceni();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrollBar2Change(TObject *Sender)
{
KRITERIUM = (double) ScrollBar2->Position/10.0;
Label22->Caption = KRITERIUM;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
VykresliPerceptrony();
}
//---------------------------------------------------------------------------

