//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <Mask.hpp>
#include <ExtCtrls.hpp>

#define H 5
#define I 8
#define O 8
#define IH I*H
#define OH O*H
#define gama 1.0
#define ny   0.75
#define alfa 0.25
#define MAX_POC_CYKLU 10
#define POCET_VZORU 'z'-'a' + 'Z'-'A' +2
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TBitBtn *BitBtn1;
        TGroupBox *GroupBox1;
        TMaskEdit *MaskEdit1;
        TEdit *Edit1;
        TEdit *Edit2;
        TEdit *Edit3;
        TEdit *Edit4;
        TEdit *Edit5;
        TEdit *Edit6;
        TEdit *Edit7;
        TEdit *Edit8;
        TEdit *Edit9;
        TEdit *Edit10;
        TEdit *Edit11;
        TEdit *Edit12;
        TEdit *Edit13;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TBitBtn *BitBtn2;
        TBitBtn *BitBtn3;
        TTimer *Timer1;
        TLabel *Label6;
        TLabel *Label7;
        TMaskEdit *MaskEdit2;
        TMaskEdit *MaskEdit3;
        TMaskEdit *MaskEdit4;
        TMaskEdit *MaskEdit5;
        TMaskEdit *MaskEdit6;
        TMaskEdit *MaskEdit7;
        TMaskEdit *MaskEdit8;
        TScrollBar *ScrollBar1;
        TLabel *Label4;
        TLabel *Label9;
        TLabel *Label10;
        TMaskEdit *MaskEdit9;
        TLabel *Label11;
        TLabel *Label12;
        TLabel *Label13;
        TLabel *Label14;
        TLabel *Label15;
        TLabel *Label16;
        TLabel *Label17;
        TLabel *Label18;
        TLabel *Label19;
        TLabel *Label21;
        TLabel *Label22;
        TGroupBox *GroupBox2;
        TLabel *Label5;
        TBitBtn *BitBtn4;
        TLabel *Label20;
        TBitBtn *BitBtn5;
        TStaticText *StaticText1;
        TStaticText *StaticText2;
        TStaticText *StaticText3;
        TBevel *Bevel1;
        TStaticText *StaticText4;
        TScrollBar *ScrollBar2;
        TStaticText *StaticText5;
        TCheckBox *CheckBox2;
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall BitBtn4Click(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall ScrollBar1Change(TObject *Sender);
        void __fastcall BitBtn2Click(TObject *Sender);
        void __fastcall BitBtn5Click(TObject *Sender);
        void __fastcall ScrollBar2Change(TObject *Sender);
        void __fastcall CheckBox2Click(TObject *Sender);
private:	// User declarations
        double vstupy[I];
        double perceptronyI[I];

        double wIH[I][H]; // vahy
        double deltawIH[I][H];

        double perceptronyH[H];
        double prahyH[H];
        double deltaprahyH[H];

        double wHO[H][O];
        double deltawHO[H][O];

        double pozadovane_vystupy[O];
        double perceptronyO[O];
        double prahyO[O];
        double deltaprahyO[O];
        double vystupy[O];
        double chyby_vystupu[O];

        double E,Eo; //celkova energie; energie
        double KRITERIUM;
        unsigned int pocet_cyklu;
        char vzor;
        char polevzoru[POCET_VZORU];


        void VykresliPerceptrony();
        void PrerusUceni();
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
        void priloz_vybrany_vzor_na_vstupy_site(unsigned char krok);
        void vypocti_vystupy_site();
        void porovnej_vystupy_s_pozadovanymi_hodnotami();
        void modifikuj_vahy();
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
